// ps2proto.c

//#define __TEST


#include <avr/io.h>
#include <avr/delay.h>

#include <inttypes.h>

#include "ps2.h"
#include "ps2proto.h"

#include <avr\pgmspace.h>

//#include "ps2protomaps.h"



#ifdef __TEST
#include <avr/delay.h>
#include <avr/interrupt.h>
#include "strio.h"
#include "usart.h"
#endif // TEST




static uint8_t lastSentByte = 0xaa;

static void Delay180us(void)
{
  _delay_loop_2(500); // 180us
}

void LocalSendByte(uint8_t byte)
{
  lastSentByte = byte;
  SendPS2Byte(byte);
  _delay_loop_2(5000); // ~1800us    
}


void PS2_Proto( void )
{
  uint8_t  data,data2;
 
  if (CheckForHostRequest()) {

    data2 = 0;
    Delay180us(); // 180us

    if (ReadPS2Byte(&data)) {
      LocalSendByte(0xfe);
    } else {
			switch (data) {
				case 0xfe:
					SendPS2Byte(lastSentByte);
					break;
				case 0xee:
					LocalSendByte(0xee);
					break;
				case 0xf2:
					LocalSendByte(0xab);
					LocalSendByte(0x83);
					break;
				case 0xff:
					LocalSendByte(0xfa);
		      LocalSendByte(0xaa);
				case 0xed:
				case 0xf0:
				case 0xf3:
					LocalSendByte(0xfa);
				  // wait for computer to be ready to respond
			    while (!CheckForHostRequest());
					ReadPS2Byte(&data);
					Delay180us(); // 180us
					LocalSendByte(0xfa);
					break;
				default:
					LocalSendByte(0xfa);
					break;
			}
    }
	}
}




#ifdef __TEST

// Code OK, es werden 'a' gesendet. Hohe Frequenz

int main (int argc, char **argv)
{

  initPS2IO();
	usart_init();

  sei();

	sputs ("PS2 Prototest\r\n");
	_delay_loop_2(5000); // ~1800us
	_delay_loop_2(5000); // ~1800us        
	_delay_loop_2(5000); // ~1800us
  SendPS2Byte(0xaa);	
	_delay_loop_2(5000); // ~1800us

  while (1) {
		PS2_Proto();			
		SendPS2Byte(0x1C);		
  	_delay_loop_2(5000); // ~1800us
		SendPS2Byte(0xC0);		
  	_delay_loop_2(5000); // ~1800us
		SendPS2Byte(0x1C);		
  	_delay_loop_2(5000); // ~1800us
  }

  return 0;
}

#endif // __TEST


