
#include <avr/pgmspace.h>

#include "usart.h"
#include "strio.h"


static const char hextable[] PROGMEM =	{ '0', '1', '2', '3', 
																 	        '4', '5', '6', '7',
				  											  	      '8', '9', 'A', 'B',
							  									        'C', 'D', 'E', 'F' };

static const char crlf[] PROGMEM = "\n\r";

static void _csputs (const char *str)
{
  while (PRG_RDB(str)) {
    usart_transmit(PRG_RDB(str));
    str++;
  }       
}

void csputs (const char *str)
{
  _csputs (str);
  _csputs(crlf);
}

void sputs (const char *str)
{
	while (*str) {
		usart_transmit (*str);
		str++;
	}
  _csputs(crlf);
}

void printHEX(unsigned char value)
{
	usart_transmit(PRG_RDB(&hextable[(value >> 4) & 0x0f]));
	usart_transmit(PRG_RDB(&hextable[value & 0x0f]));
}
